Overview | Package | Class | Deprecated | Index | Help
| Groovy 1.7.6
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | PROPERTY | CONSTR | METHOD | DETAIL: FIELD | PROPERTY | CONSTR | METHOD

## groovy.mock.interceptor
[Groovy] Class StubFor

    java.lang.Object
      groovy.mock.interceptor.StubFor

    class StubFor
    extends Object

StubFor supports (typically unit) testing of classes in isolation by allowing a loosely-ordered expectation of the behavior of collaborators to be defined. A typical test scenario involves a class under test (CUT) and one or more collaborators. In such a scenario it is often desirable to just test the business logic of the CUT. One strategy for doing that is to replace the collaborator instances with simplified stub objects to help isolate out the logic in the CUT. StubFor allows such stubs to be created using meta-programming. The desired behavior of collaborators is defined as a behavior specification. The behavior can be checked by the user using verify(). With StubFor, a stub's expectation is sequence independent and use of verify() is left to the user. Typical usage is as follows:

     import groovy.mock.interceptor.StubFor

     class Person {
       String first, last
     }

     class Family {
       Person mother, father
       def nameOfFather() { "$father.first $father.last" }
     }

     def stub = new StubFor(Person)
     stub.demand.with {
       getLast{ 'name' }
       getFirst{ 'dummy' }
     }
     stub.use {
       def john = new Person(first:'John', last:'Smith')
       def f = new Family(father:john)
       assert f.nameOfFather() == 'dummy name'
     }
     stub.expect.verify()

Here, `Family` is our class under test and `Person` is the collaborator. We are using normal Groovy property semantics here; hence the statement `father.first` causes a call to `father.getFirst()` to occur. For a complete list of features, see: MockFor.

Authors:
  Dierk Koenig
  Paul King

Property Summary
`Class` | `clazz`
`Demand` | `demand`
`def` | `expect`
`Ignore` | `ignore`
`Map` | `instanceExpectations`
`MockProxyMetaClass` | `proxy`

Constructor Summary
`StubFor(Class clazz, boolean interceptConstruction = false)`

Method Summary
`def` | `ignore(Object filter, Closure filterBehavior = null)` Allows particular method calls to be ignored and not treated as part of the required behavior specification.
`GroovyObject` | `makeProxyInstance(def args, boolean isDelegate)`
`GroovyObject` | `proxyDelegateInstance(def args = null)` Allows a more traditional instance-style stubbing paradigm.
`GroovyObject` | `proxyInstance(def args = null)` Allows a more traditional instance-style stubbing paradigm.
`void` | `use(Closure closure)` @See MockFor#use(Closure)
`void` | `use(GroovyObject obj, Closure closure)`
`void` | `verify(GroovyObject obj)` For manual verification
`void` | `verify()` Convenience method

Methods inherited from class Object
wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll

Property Detail

### clazz

    Class clazz

### demand

    Demand demand

### expect

    def expect

### ignore

    Ignore ignore

### instanceExpectations

    Map instanceExpectations

### proxy

    MockProxyMetaClass proxy

Constructor Detail

### StubFor

    StubFor(Class clazz, boolean interceptConstruction = false)

Method Detail

### ignore

    def ignore(Object filter, Closure filterBehavior = null)

  Allows particular method calls to be ignored and not treated as part of the required behavior specification. If you don't specify a return closure the method call will fall through to the underlying instance, i.e. half-mock style. The `filter` object is invoked using the normal Groovy `isCase()` semantics.
  See:
    MockFor#ignore(Object, Closure)

### makeProxyInstance

    GroovyObject makeProxyInstance(def args, boolean isDelegate)

### proxyDelegateInstance

    GroovyObject proxyDelegateInstance(def args = null)

  Allows a more traditional instance-style stubbing paradigm. This is the recommended method to call to use the instance-style with Java classes.
  See:
    MockFor#proxyDelegateInstance(Object)

### proxyInstance

    GroovyObject proxyInstance(def args = null)

  Allows a more traditional instance-style stubbing paradigm. This is the recommended method to call to use the instance-style with Groovy classes.
  See:
    MockFor#proxyInstance(Object)

### use

    void use(Closure closure)

  See:
    MockFor#use(Closure)

### use

    void use(GroovyObject obj, Closure closure)

### verify

    void verify(GroovyObject obj)

  For manual verification

### verify

    void verify()

  Convenience method

Copyright © 2003-2010 The Codehaus. All rights reserved.